/*
 *        .
 *   .
 * ver 1.7
 */ 

#include "Display.h"
#include "Clock.h"

//******************    **************************
volatile u08 Shift = 0;										//0 -   .    . 1 -   .  
volatile u08 CountShift = INFINITY_CREEP;					//    .  0 -      ,  INFINITY_CREEP -  ,   
u08 StrLen = 0;												//     DisplayStr.    (Shift = 0)    

//******************   ***********************************
#define NUM_DISPLAYS			9							//     
#define STR_LENGTH	DISP_COL*NUM_DISPLAYS					//  
u08 DisplayStr[STR_LENGTH];									//   .        .

//******************    ***************
const u08 PROGMEM											//    
	CellsCoord [4] = {0, 6, 13, 19 };
u08 FlashFlag;												//  1  0      
u08 FlashDigit;												//     

//******************    **************************
u08 CellsBuf[FONT_LENGTH * CELLS_DISP];						//     
u08 CellsVertPos[CELLS_DISP];								//      
u08	Cells[4];												//    .      -   -  -  -  -  
volatile u08 VertSpeed = VERT_SPEED;						//  

//******************  **********************************************
#define LEnd									0xAA		//   .     0! ..      . 0x             .
u08 CurrentIdFont = 0;										// 

//******************   *****************************************
const u08 PROGMEM
	Font [FONT_COUNT_MAX-1][10][FONT_LENGTH] =
	{
		{//--------------------  1
			{ 0x7F, 0x7F, 0x41, 0x7F, 0x7F },
			{ 0x00, 0x00, 0x7F, 0x7F, 0x00 },
			{ 0x61, 0x71, 0x59, 0x4F, 0x47 },
			{ 0x41, 0x49, 0x49, 0x7F, 0x7F },
			{ 0x1F, 0x1F, 0x10, 0x7F, 0x7F },
			{ 0x4F, 0x4F, 0x49, 0x79, 0x79 },
			{ 0x7F, 0x7F, 0x49, 0x79, 0x79 },
			{ 0x01, 0x71, 0x79, 0x0F, 0x07 },
			{ 0x7F, 0x7F, 0x49, 0x7F, 0x7F },
			{ 0x5F, 0x5F, 0x51, 0x7F, 0x7F },
		},
		{//--------------------  2
			{ 0x7F, 0x7F, 0x41, 0x7F, 0x7F },
			{ 0x00, 0x01, 0x7F, 0x7F, 0x00 },
			{ 0x63, 0x73, 0x59, 0x4F, 0x47 },
			{ 0x63, 0x63, 0x49, 0x7F, 0x77 },
			{ 0x1F, 0x1F, 0x10, 0x7F, 0x7F },
			{ 0x6F, 0x6F, 0x49, 0x79, 0x79 },
			{ 0x7F, 0x7F, 0x49, 0x7B, 0x7B },
			{ 0x03, 0x73, 0x79, 0x0F, 0x07 },
			{ 0x77, 0x7F, 0x49, 0x7F, 0x77 },
			{ 0x6F, 0x6F, 0x49, 0x7F, 0x7F },
		},
		{//--------------------  3
			{ 0x7F, 0x41, 0x41, 0x7F, 0x7F },
			{ 0x00, 0x00, 0x7F, 0x7F, 0x00 },
			{ 0x61, 0x71, 0x59, 0x4F, 0x47 },
			{ 0x41, 0x49, 0x49, 0x7F, 0x7F },
			{ 0x1F, 0x10, 0x10, 0x7F, 0x7F },
			{ 0x4F, 0x49, 0x49, 0x79, 0x79 },
			{ 0x7F, 0x49, 0x49, 0x79, 0x79 },
			{ 0x01, 0x01, 0x01, 0x7F, 0x7F },
			{ 0x7F, 0x49, 0x49, 0x7F, 0x7F },
			{ 0x1F, 0x11, 0x11, 0x7F, 0x7F },
		},
		{//--------------------  4
			{ 0x7F, 0x41, 0x41, 0x7F, 0x7F },
			{ 0x00, 0x01, 0x7F, 0x7F, 0x00 },
			{ 0x63, 0x71, 0x59, 0x4F, 0x47 },
			{ 0x63, 0x41, 0x49, 0x7F, 0x7F },
			{ 0x1F, 0x10, 0x10, 0x7F, 0x7F },
			{ 0x6F, 0x49, 0x49, 0x79, 0x79 },
			{ 0x7F, 0x49, 0x49, 0x7B, 0x7B },
			{ 0x03, 0x01, 0x01, 0x7F, 0x7F },
			{ 0x7F, 0x49, 0x49, 0x7F, 0x7F },
			{ 0x1F, 0x11, 0x11, 0x7F, 0x7F },
		},
		{//--------------------  5
			{ 0x3E, 0x7F, 0x41, 0x7F, 0x3E },
			{ 0x00, 0x02, 0x7F, 0x7F, 0x00 },
			{ 0x62, 0x73, 0x59, 0x4F, 0x46 },
			{ 0x22, 0x63, 0x49, 0x7F, 0x36 },
			{ 0x18, 0x14, 0x12, 0x7F, 0x7F },
			{ 0x2F, 0x6F, 0x45, 0x7D, 0x39 },
			{ 0x3E, 0x7F, 0x49, 0x7B, 0x32 },
			{ 0x03, 0x73, 0x79, 0x0F, 0x07 },
			{ 0x36, 0x7F, 0x49, 0x7F, 0x36 },
			{ 0x2E, 0x6F, 0x49, 0x7F, 0x3E },
		},
		{//--------------------  6
			{ 0x3E, 0x41, 0x41, 0x7F, 0x3E },
			{ 0x00, 0x02, 0x7F, 0x7F, 0x00 },
			{ 0x62, 0x71, 0x59, 0x4F, 0x46 },
			{ 0x22, 0x41, 0x49, 0x7F, 0x36 },
			{ 0x18, 0x14, 0x12, 0x7F, 0x7F },
			{ 0x2F, 0x45, 0x45, 0x7D, 0x39 },
			{ 0x3E, 0x49, 0x49, 0x7B, 0x32 },
			{ 0x03, 0x71, 0x79, 0x0F, 0x07 },
			{ 0x36, 0x49, 0x49, 0x7F, 0x36 },
			{ 0x26, 0x49, 0x49, 0x7F, 0x3E },
		},
	};

/************************************************************************/
/*   .  0xAA           */
/************************************************************************/
const u08 PROGMEM letters [][FONT_LENGTH] =
{
	//--------------------   0
	{ 0x3E, 0x51, 0x49, 0x45, 0x3E },  // 0		 0  9   
	{ 0x00, 0x42, 0x7F, 0x40, 0x00 },  // 1
	{ 0x42, 0x61, 0x51, 0x49, 0x46 },  // 2
	{ 0x21, 0x41, 0x45, 0x4B, 0x31 },  // 3
	{ 0x18, 0x14, 0x12, 0x7F, 0x10 },  // 4
	{ 0x27, 0x45, 0x45, 0x45, 0x39 },  // 5
	{ 0x3C, 0x4A, 0x49, 0x49, 0x30 },  // 6
	{ 0x01, 0x71, 0x09, 0x05, 0x03 },  // 7
	{ 0x36, 0x49, 0x49, 0x49, 0x36 },  // 8
	{ 0x06, 0x49, 0x49, 0x29, 0x1E },  // 9
	//--------------------    
	{ 0x7C, 0x12, 0x12, 0x7C, LEnd },  //   10
	{ 0x7E, 0x4A, 0x4A, 0x32, LEnd },  //   11
	{ 0x7E, 0x4A, 0x4A, 0x34, LEnd },  //   12
	{ 0x7E, 0x02, 0x02, LEnd, 0x00 },  //   13
	{ 0x60, 0x3C, 0x22, 0x3E, 0x60 },  //   14
	{ 0x7E, 0x4A, 0x4A, LEnd, 0x00 },  //   15
	{ 0x66, 0x18, 0x7E, 0x18, 0x66 },  //   16
	{ 0x24, 0x42, 0x4A, 0x34, 0x00 },  //   17
	{ 0x7E, 0x10, 0x08, 0x7E, LEnd },  //   18
	{ 0x7C, 0x11, 0x09, 0x7C, LEnd },  //   19
	{ 0x7E, 0x18, 0x24, 0x42, LEnd },  //   20
	{ 0x78, 0x04, 0x02, 0x7E, LEnd },  //   21
	{ 0x7E, 0x04, 0x08, 0x04, 0x7E },  //   22
	{ 0x7E, 0x08, 0x08, 0x7E, LEnd },  //   23
	{ 0x3C, 0x42, 0x42, 0x3C, LEnd },  //   24
	{ 0x7E, 0x02, 0x02, 0x7E, LEnd },  //   25
	{ 0x7E, 0x12, 0x12, 0x0C, LEnd },  //   26
	{ 0x3C, 0x42, 0x42, 0x24, LEnd },  //   27
	{ 0x02, 0x7E, 0x02, LEnd, 0x00 },  //   28
	{ 0x4E, 0x50, 0x50, 0x3E, LEnd },  //   29
	{ 0x0C, 0x12, 0x7E, 0x12, 0x0C },  //   30
	{ 0x66, 0x18, 0x18, 0x66, LEnd },  //   31
	{ 0x7E, 0x40, 0x40, 0x7E, 0xC0 },  //   32
	{ 0x0E, 0x10, 0x10, 0x7E, LEnd },  //   33
	{ 0x7E, 0x40, 0x7E, 0x40, 0x7E },  //   34
	{ 0x7E, 0x40, 0x7E, 0x40, 0xFE },  //   35
	{ 0x02, 0x7E, 0x48, 0x30, LEnd },  //   36
	{ 0x7E, 0x48, 0x30, 0x00, 0x7E },  //   37
	{ 0x7E, 0x48, 0x30, LEnd, 0x00 },  //   38
	{ 0x24, 0x42, 0x4A, 0x3C, LEnd },  //   39
	{ 0x7E, 0x08, 0x3C, 0x42, 0x3C },  //   40
	{ 0x4C, 0x32, 0x12, 0x7E, LEnd },  //   41
	{ 0x7E, 0x42, 0x42, 0x3C, LEnd },  // D	 42
	{ 0x7E, 0x12, 0x02, LEnd, 0x00 },  // F  43
	{ 0x3C, 0x42, 0x52, 0x24, LEnd },  // G  44
	{ 0x7E, LEnd, 0x00, 0x00, 0x00 },  // I  45
	{ 0x30, 0x40, 0x40, 0x3E, LEnd },  // J  46
	{ 0x7E, 0x40, 0x60, LEnd, 0x00 },  // L  47
	{ 0x7E, 0x04, 0x08, 0x10, 0x7E },  // N  48
	{ 0x3C, 0x42, 0x42, 0x3C, 0x40 },  // Q  49
	{ 0x7E, 0x12, 0x32, 0x4C, LEnd },  // R  50
	{ 0x24, 0x4A, 0x4A, 0x30, 0x00 },  // S  51
	{ 0x3E, 0x40, 0x40, 0x3E, 0x00 },  // U  52
	{ 0x02, 0x3C, 0x40, 0x3C, 0x02 },  // V  53
	{ 0x3E, 0x40, 0x30, 0x40, 0x3E },  // W  54
	{ 0x02, 0x0C, 0x70, 0x0C, 0x02 },  // Y  55
	{ 0xC6, 0xA2, 0x92, 0x8A, 0xC6 },  // Z  56
	{ 0x00, 0x00, LEnd, 0x00, 0x00 },  //               ZN_SPACE		57
	{ 0x40, LEnd, 0x00, 0x00, 0x00 },  //                ZN_DOT		58
	{ 0x00, LEnd, 0x00, 0x00, 0x00 },  //      ZN_SPICA		59
	{ 0x00, 0x00, 0x00, 0x00, 0x00 },  // ""      ZN_BLANK		60
	{ 0x08, 0x08, 0x08, 0x08, 0x08 },  //                ZN_MINUS		61
	{ 0x08, 0x08, 0x3E, 0x08, 0x08 },  //                 ZN_PLUS		62
	{ 0x06, 0x09, 0x09, 0x06, LEnd },  //          ZN_CELS		63
	{ 0x04, 0x3F, 0x44, 0x20, LEnd },  //  t         ZN__LTL_T		64
	{ 0x08, 0x08, 0x08, LEnd, 0x00 },  //       ZN_LTL_MINUS	65
	{ 0x40, 0x40, 0x40, 0x40, 0x40 },  //  _     ZN_UNDER_LINE	66
};

//    
#define ZN_SPACE		57
#define ZN_DOT			58
#define ZN_SPICA		59
#define ZN_BLANK		60
#define ZN_MINUS		61
#define ZN_PLUS			62
#define ZN_CELS			63
#define ZN__LTL_T		64
#define ZN_LTL_MINUS	65
#define ZN_UNDER_LINE	66


/************************************************************************/
/*       	       */
/************************************************************************/
const u08 PROGMEM substLat[] =
{
	10,									//A     
	12,									//B	-//- 
	27,									//C	-//- 
	42,									//D
	15,									//E	-//- 
	43,									//F
	44,									//G
	23,									//H	-//- 
	45,									//I
	46,									//J
	20,									//K	-//- 
	47,									//L
	22,									//M	-//- 
	48,									//N
	24,									//O	-//- 
	26,									//P	-//- 
	49,									//Q
	50,									//R
	51,									//S
	28,									//T	-//- 
	52,									//U
	53,									//V
	54,									//W
	31,									//X	-//- 
	55,									//Y
	56									//Z
};

/************************************************************************/
/*     Col   CharCode	    */
/************************************************************************/
u08 Symbol(u08 CharCode, u08 Col){

	
	if ((CharCode <=0x9) || ((CharCode >= 0x30) && (CharCode <= 0x39))){	//        id !=0     
		if (CurrentIdFont)
			return pgm_read_byte(&Font[CurrentIdFont-1][CharCode & 0x0f][Col]);	// 1 ..       
		else
			return pgm_read_byte(&letters[CharCode & 0x0f][Col]);
	}
	else if (CharCode == 0x20)												//   
		return pgm_read_byte(&letters[ZN_SPACE][Col]);
	else if (CharCode == 0x2b)												// '+'
		return pgm_read_byte(&letters[ZN_PLUS][Col]);
	else if (CharCode == 0x2d)												// '-'
		return pgm_read_byte(&letters[ZN_MINUS][Col]);
	else if (CharCode == 0x2e)												// '.'
		return pgm_read_byte(&letters[ZN_DOT][Col]);
	else if ((CharCode >= LATIN_BEGIN_CAPITAL) && (CharCode <= LATIN_END_CAPITAL))	//   .         ,      
		return pgm_read_byte(&letters[pgm_read_byte(&substLat[CharCode-LATIN_BEGIN_CAPITAL])][Col]);
	else if ((CharCode >= LATIN_BEGIN_LOWER) && (CharCode <= LATIN_END_LOWER)){						//   .           
		if (CharCode == 0x74)												//  t
			return pgm_read_byte(&letters[ZN__LTL_T][Col]);
		else
			return pgm_read_byte(&letters[pgm_read_byte(&substLat[CharCode-LATIN_BEGIN_LOWER])][Col]);
	}
	else if (CharCode == 0x96)												//  ,    Win-1251
		return pgm_read_byte(&letters[ZN_LTL_MINUS][Col]);
	else if (CharCode == 0x98)												//    ,    BLANK_SPACE
		return pgm_read_byte(&letters[ZN_BLANK][Col]);
	else if (CharCode == 0xa0)												//    ,    S_SPICA
		return pgm_read_byte(&letters[ZN_SPICA][Col]);
	else if (CharCode == 0xb0)												// 
		return pgm_read_byte(&letters[ZN_CELS][Col]);
	else if ((CharCode >= CYRILLIC_BEGIN_CAPITAL) && (CharCode <= CYRILLIC_END_LOWER)){	// ,   
		if (CharCode <= CYRILLIC_END_CAPITAL)								//
			return pgm_read_byte(&letters[CharCode-182][Col]);
		else
			return pgm_read_byte(&letters[CharCode-214][Col]);				//
	}
	else																	//    
		return pgm_read_byte(&letters[ZN_UNDER_LINE][Col]);
}

/************************************************************************/
/*                                                       */
/************************************************************************/
void FlashSwitch(void){
	FlashFlag = (FlashFlag == 0)?1:0;
	SetTimerTask(FlashSwitch, 500);
}

/************************************************************************/
/*         */
/************************************************************************/
struct sCellPos CellToPos(u08 Value){

	struct sCellPos Ret;
	if (Value <= CELLS_DISP-1){
		Ret.Start = pgm_read_byte(&CellsCoord[Value]);
		Ret.Stop = pgm_read_byte(&CellsCoord[Value])+FONT_LENGTH-1;
	}
	else{
		Ret.Start = pgm_read_byte(&CellsCoord[0]);
		Ret.Stop = pgm_read_byte(&CellsCoord[0])+FONT_LENGTH-1;
	}
	return Ret;
}

/************************************************************************/
/*      .  UNDEF_POS   */
/*     								    */
/************************************************************************/
u08 PosToCell(u08 Value){
	u08 i;
	struct sCellPos Cell;
	
	if (Value>DISP_COL) return UNDEF_POS;
	for(i=0; i<CELLS_DISP;i++){
		Cell = CellToPos(i);
		if ((Value>=Cell.Start) && (Value<=Cell.Stop))
			return i;
	}
	return UNDEF_POS;
}
/************************************************************************/
/*         				*/
/*     Shift.  Shift = 0        */
/*      					*/
/************************************************************************/
void ShowWindow(void){
	static u08 Pos = 0, PrevShift = 0;
	static u08 StartWindow = DISP_COL, LenWindow = DISP_COL;
	
	u08 i, f;

	if ((PrevShift != Shift) && (!PrevShift)){				//     
		StartWindow = DISP_COL;								//   , ..       
		LenWindow = 0; 
		ClearScreen();
	}
	PrevShift = Shift;
	if (Shift == 0){										// 
		Pos = 0;
		StartWindow = 0;								
		LenWindow = DISP_COL;
		for (i=0; i<DISP_COL; i++){							//   
			f = PosToCell(i);
			if (f != UNDEF_POS)
				DisplayBuf[i] = (BitIsSet(FlashDigit, f) && (FlashFlag == 0))?0:DisplayStr[i];
			else
				DisplayBuf[i] = DisplayStr[i];
		}
		SetTimerTask(ShowWindow, HORIZON_SPEED);
		return;
	}
	else if (Shift == 1){									//  
		if ((Pos+Shift+DISP_COL) > StrLen){					//  ,  
			CountShift -= (CountShift == INFINITY_CREEP)?0:1;//     
			if (!CountShift){ 								//   ,  
				Shift = 0;
				ClearDisplay();
				SetTimerTask(ShowWindow, HORIZON_SPEED);
				return;
			}
			if (StrLen > DISP_COL){							//          
				if (LenWindow){								//        
					LenWindow--;							//    
					Pos += ((Pos+Shift)>StrLen)?0:Shift;	//             
				}
				else{										//  
					LenWindow = 0;
					StartWindow = DISP_COL;					//   , ..       
					Pos = 0;
					ClearScreen();
				}
			}
		}
		else												//   ,  
			Pos += (StartWindow == 0)?Shift:0;				//          
	}
	if (StartWindow){										//     .
		StartWindow--;
		LenWindow++;
	}
	memcpy(&DisplayBuf[StartWindow], &DisplayStr[Pos], LenWindow);
	SetTimerTask(ShowWindow, HORIZON_SPEED);
}

/************************************************************************/
/*                                                        */
/************************************************************************/
void ClearDisplay(void){
	u08 i;
	
	for (i=0;i<=STR_LENGTH;i++)								//  
		DisplayStr[i] = 0;
	StrLen = 0;												//  
	FlashDigit = 0;											//  
	Shift = 0;												// 
	ShowWindow();											//  
}

/************************************************************************/
/*                              */
/************************************************************************/
void ClearVertDisplay(void){
	u08 i;
	for (i=0; i<CELLS_DISP; i++){
		Cells[i] = 0xff;									//       0  9
		CellsVertPos[i] = 0;								//  
	}
}

/************************************************************************/
/*    ,            */
/************************************************************************/
void ScrollingVert(){
	u08 i, j,  Cell;
	struct sCellPos CellPos;
	
	for (Cell=0; Cell<CELLS_DISP; Cell++){
		if (!CellsVertPos[Cell]) continue;				//   , 
		CellPos = CellToPos(Cell);						//  
		if (VertSpeed != VERT_SPEED_FAST){				//  ,     ,  
			for (i = CellPos.Start, j=0; i <= CellPos.Stop; i++, j++)
				DisplayStr[i] = 
						((DisplayStr[i]<<1) & 0xfe)		//   
						|								//  
						((CellsBuf[Cell*FONT_LENGTH+j] >> (7-CellsVertPos[Cell])) &	0x1);//  
			CellsVertPos[Cell]++;						//  
		}
		else
			CellsVertPos[Cell] = 8;
		if (CellsVertPos[Cell] == 8){
			CellsVertPos[Cell] = 0;						// 
			for (i = CellPos.Start, j=0; i <= CellPos.Stop; i++, j++)	//  
				DisplayStr[i] = CellsBuf[Cell *FONT_LENGTH+j];
		}
	}
	SetTimerTask(ScrollingVert, VertSpeed);
}

/************************************************************************/
/*       .  						*/
/*    StartPos -                          */
/*       			                */
/*     0                         */
/*         			*/
/*         sputc()                  */
/************************************************************************/
u08 DecodeValue(u08 Value, u08 StartPos){
	u08 i;
	
	if ((StartPos+FONT_LENGTH) >= STR_LENGTH)			//  ,   
		return 0;
	for (i=0; i < FONT_LENGTH; i++){
		if (Symbol(Value, i) == LEnd) break;
		DisplayStr[StartPos+i] = Symbol(Value, i);
	}
	return i;
}

/************************************************************************/
/*                                   */
/* NumCell -     .      */
/*  					                                */
/************************************************************************/
void sputc(u08 Value, u08 NumCell){
	u08 j, i;
	
	if ((StrLen+FONT_LENGTH)>STR_LENGTH) return;		// 
	if (!Shift){										// ,     
		StrLen = DISP_COL;								//     
		if (NumCell > CELLS_DISP-1) return;				//     
		if (Value == S_FLASH_ON)						//  
			SetBit(FlashDigit, NumCell);
		else if (Value == S_FLASH_OFF)					//  
			ClearBit(FlashDigit, NumCell);
		else {											//  
			if (Cells[NumCell] != Value){				// ,      
				i = 0;
				for (j=0; j < FONT_LENGTH; j++){		//      
					i = i | (Symbol(Value, j) == LEnd)?1:0;	//    ..  ,   
					CellsBuf[(NumCell*FONT_LENGTH)+j] = i?0:Symbol(Value, j);//      
				}
				CellsVertPos[NumCell] = 1;				// 
			}
			else{										//  ,   ,   
				CellsVertPos[NumCell] = 0;				//  
				DecodeValue(Value, CellToPos(NumCell).Start);
			}
			Cells[NumCell] = Value;
		}
	}
	else												//   
		StrLen += DecodeValue(Value, StrLen);			//           
}

/************************************************************************/
/*    . On=1  , 0 -            */
/*     ,       */
/************************************************************************/
//TODO            
void plot(u08 x, u08 y, u08 On){
	if ((x>=DISP_COL) || (y>=8)) return;
	if (!Shift)
		SetBitVal(DisplayStr[x], y, On);
}

/************************************************************************/
/*     , 1 - , 0 -      */
/************************************************************************/
u08 DotIsSet(u08 x, u08 y){
	if ((x>=DISP_COL) || (y>=8)) return 0;
	if BitIsSet(DisplayStr[x], y) return 1;
	else return 0;
}

/************************************************************************/
/*                                      */
/************************************************************************/
void NextFont(void){
	CurrentIdFont = (CurrentIdFont+1 == FONT_COUNT_MAX)?0:CurrentIdFont+1;
	if (Refresh != NULL){
		ClearDisplay();
		Refresh();
	}
}

/************************************************************************/
/*  												*/
/************************************************************************/
void DisplayInit(void){
	u08 i;
	
	DispRefreshIni();									//  
	SetTimerTask(FlashSwitch, 250);						// 
	
	CurrentIdFont = 0;

	for (i=0; i< FONT_LENGTH * CELLS_DISP; i++)
		CellsBuf[i] = 0;								//       
	for (i=0; i<CELLS_DISP; i++)
		CellsVertPos[0] = 0;							//   
	FlashDigit = 0;										//  

	ClearDisplay();										// 
	Shift = 0;											// 
	ShowWindow();										//    .
	ScrollingVert();									//  .
}