/*
 * Display.h
	     .
	
		       .       . 
	            
	     .
		           . ..   
	       .
		 sputc          .
		    sputs      .      
	- ,        Windows-1251    .   
	        :
		-  0x0  0x9   ; 
		-  0xa  0x2f   ,    :
			0x11    .     sputc    .
			0x12    .     sputc    .
			0x20    
			0x2b      Win-1251
			0x2d      Win-1251
			0x2e      Win-1251
		-  0x30  0x39   ;
		-  0x3a  0x40    (    ASCII)
		-  0x41  0x5a       ASCII,         "t",     
		-  0x5b  0x60   , (    ASCII)
			0x5f         Win-1251
		-  0x61  0x7a   0x41-0x5a
		-  0x7b  0xbf   ,   :
			0x96       Win-1251
			0x98     ,    BLANK_SPACE
			0xa0     ,    S_SPICA
			0xb0       Win-1251
		-  0xc0  0xff        Win-1251. 
			   0xc0  0xdf    0xe0  0xff. 
 ver 1.4
 */ 


#ifndef DISPLAY_H_
#define DISPLAY_H_

#include <avr\io.h>
#include <avr\pgmspace.h>
#include <string.h>
#include "bits_macros.h"
#include "avrlibtypes.h"
#include "EERTOS.h"
#include "DisplayHAL.h"

#define VERT_SPEED					100			//     
#define VERT_SPEED_FAST			VERT_SPEED/10	//         
#define INFINITY_CREEP				0xff		//     
#define HORIZON_SPEED				100			//  

//*************   
#define CELLS_DISP					4			//      
#define DIGIT0						3			// 
#define DIGIT1						2
#define DIGIT2						1
#define DIGIT3						0			// 
#define UNDEF_POS					0xff		// 

//******************   **********************************************
#define FONT_LENGTH					5			//    
#define FONT_COUNT_MAX				7			//  ,         

//***************    Windows-1251      
#define S_SPACE						0x20		//   
#define S_PLUS						0x2b		// '+'
#define S_MINUS						0x2d		// '-'
#define S_DOT						0x2e		// '.'
#define S_LTL_MINUS					0x96		//  
#define S_CELSI						0xb0		//  
#define S_UNDELINE					0x5f		// 

//***************     Windows-1251
#define S_SPICA						'\xa0'		// 
#define BLANK_SPACE					0x98		// 
#define S_FLASH_ON					0x11		//  
#define S_FLASH_OFF					0x12		//  

//***************  
#define LATIN_BEGIN_CAPITAL			0x41		//   
#define LATIN_END_CAPITAL			0x5a
#define LATIN_BEGIN_LOWER			0x61		//   
#define LATIN_END_LOWER				0x7a
#define CYRILLIC_BEGIN_CAPITAL		0xc0
#define CYRILLIC_END_CAPITAL		0xdf
#define CYRILLIC_BEGIN_LOWER		0xe0
#define CYRILLIC_END_LOWER			0xff

struct sCellPos{								//       
	u08 Start;
	u08 Stop;
};

void DisplayInit(void);
void sputc(u08 Value, u08 NumCell);				//   
void plot(u08 x, u08 y, u08 On);				//  
struct sCellPos CellToPos(u08 Value);			//      
u08 DotIsSet(u08 x, u08 y);						//    , 1 - , 0 -
void ClearDisplay(void);						// 
void ClearVertDisplay(void);					//  
void NextFont(void);							//   
extern volatile u08 Shift;						//  0    
extern volatile u08 CountShift;					//    .  0 -      ,  0xff -  ,   
extern volatile u08 VertSpeed;					//  
extern u08 CurrentIdFont;						//   

#endif /* DISPLAY_H_ */