/*
 *   
 * ,   ..
 *      sensor.txt  SD-
 *   ,       :
 * -     "N"  N      ,  0  SENSOR_MAX
 * -      SENSOR_ADR_MASK  0   2.       1       0
 *        :
 * N=XXX  N -    ; XXX -    ,    .   0, 0xa, 0xd
 *      -           0,
 *      ,   ,    ( ). 
 *         SD-      
 *  v1.2
 */ 


#ifndef SENSORS_H_
#define SENSORS_H_

#include "Clock.h"

//    : 
//   1-ware      ,   6.
#define SENSOR_MAX			3						//  ,   8.   ,             
#if (SENSOR_MAX>8)
	#error "Value of the SENSOR_MAX must be less than 8"	//        
#endif

#define SENSOR_LEN_NAME		3						//  
#define SENSOR_MAX_PERIOD	30						//          .    ,   

struct sSensor{										// ,   ..  eeprom   Adr, State, Name
	u08 Adr;										// .    1,2,3.  0   0      1 .             -
	u08 Value;										//  ,    u16
	u08 State;										// . ,    .   4    ,   4    
	u08 SleepPeriod;								//           .  
	char Name[SENSOR_LEN_NAME];						//     
};

//-------------------------------   State   sSensor
// TODO:            
													//  7  4   
#define	SENSOR_NO_SENSOR	7						//   1 -    
#define	SENSOR_LOW_POWER	6						//   1 -     
#define	SENSOR_TEST			5						//  -   Test, 1 -   
#define	SENSOR_RESERV		4						//--------    
													//  3  0   
#define SENSOR_SHOW_ON		3						//     
#define SENSOR_RESERV_CLK1	2						//--------    
#define SENSOR_RESERV_CLK2	1
#define SENSOR_RESERV_CLK3	0

#define SENSOR_ADR_MASK		0b00001110				//  
#define SENSOR_STATE_MASK	((1<<SENSOR_NO_SENSOR) | (1<<SENSOR_LOW_POWER) | (1<<SENSOR_TEST) | (1<<SENSOR_RESERV))	//    (  !)
#define SensorFlgClr(st)	(st.State & (~SENSOR_STATE_MASK))			//   
#define SensorIsNo(st)		BitIsSet(st.State, SENSOR_NO_SENSOR)		//   ?
#define SensorIsSet(st)		BitIsClear(st.State, SENSOR_NO_SENSOR)		//   ?
#define SensorNoInBus(st)	SetBit(st.State, SENSOR_NO_SENSOR)			//    
#define SensorSetInBus(st)	ClearBit(st.State, SENSOR_NO_SENSOR)		//   
#define	SensorBatareyIsLow(st)	BitIsSet(st.State, SENSOR_LOW_POWER)	// 
#define SensorTestModeIsOn(st)	BitIsSet(st.State, SENSOR_TEST)			// ?
#define SensorShowOn(st)		SetBit(st.State, SENSOR_SHOW_ON)		//    
#define SensorShowOff(st)		ClearBit(st.State, SENSOR_SHOW_ON)	//
#define SensorIsShow(st)		BitIsSet(st.State, SENSOR_SHOW_ON)	//     

//     .              0xc90 (-55 C)  0xff (-1 C)
#define TMPR_NO_SENS		0x80					// 
#define TMPR_BAT_LOW		0x81					//  
#define TMPR_UNDEF			0x82					//   

void SensorIni(void);								//  
void SetSensor(u08 Adr, u08 Stat, u08 Value);		// -   
struct sSensor *SensorNum(u08 id);					//    id

#define SensorFromIdx(id)	(*SensorNum(id))

#endif /* SENSORS_H_ */